import type express from 'express';
import type { Driver, OnRequestHandler, OnResponseHandler } from '../types';
declare class ExpressDriver implements Driver {
    private isActive;
    private app;
    private env;
    private onRequestHandler?;
    private onResponseHandler?;
    constructor({ app, env }: {
        app: express.Application;
        env: Record<string, string>;
    });
    setRequestInterception(arg: boolean): void;
    onRequest(fn: OnRequestHandler): Promise<() => Promise<void>>;
    onResponse(fn: OnResponseHandler): Promise<() => void>;
    onClose(fn: () => void): () => void;
}
export default ExpressDriver;
