import type { ExtractedResponse } from './response';
import type { Request, Response, DriverRequest, Interceptor } from '../types';
import type { Express } from 'express';
declare type Ret = DriverRequest & {
    onRespondPromise: Promise<RespondResolve>;
};
declare type GetRealResponse = (r: Request) => Promise<ExtractedResponse>;
declare type RealResponseResolve = {
    realResponse: ExtractedResponse;
    interceptor: Interceptor;
};
declare type MockedResponseResolve = {
    response: Response;
    interceptor: Interceptor;
};
declare type RespondResolve = RealResponseResolve | MockedResponseResolve;
export declare function extractExpressRequest(req: Express['request'], res: Express['response'], realUrl: string, getRealResponse: GetRealResponse): Promise<Ret>;
export {};
