import debug from 'debug';
const logger = debug('teremock:puppeteer:request');
let id = 0;
export async function extractExpressRequest(req, res, realUrl, getRealResponse) {
    const request = {
        url: realUrl,
        method: req.method,
        // @ts-ignore
        headers: req.headers,
        body: req.body,
        resourceType: 'xhr',
        id: id++,
        timestamp: Date.now(),
    };
    let resolve;
    let reject;
    const onRespondPromise = new Promise((r, rej) => {
        resolve = r;
        reject = rej;
    });
    const abort = async () => {
        res.status(503).end();
        reject(new Error(`abort()`));
    };
    const next = async (interceptor) => {
        // goto real backend
        const realResponse = await getRealResponse(request);
        const realResp = { realResponse, interceptor };
        resolve(realResp);
    };
    const respond = async (resp, interceptor) => {
        const mockedResp = { response: resp, interceptor };
        resolve(mockedResp);
    };
    // req.timestamp = Date.now()
    // req.teremockRequest = request
    // req.__meta = { request }
    logger(`got the request, sending it to teremock core`);
    return { request, abort, respond, next, onRespondPromise };
}
