import type { Driver, OnRequestHandler, OnResponseHandler } from '../types';
import type { Page } from 'playwright';
declare class PlaywrightDriver implements Driver {
    private page;
    private noParseResponseUrls;
    private seenRedirects;
    private _routeUrl;
    constructor({ page, noParseResponseUrls }: {
        page: Page;
        noParseResponseUrls?: string[];
    });
    setRequestInterception(_arg: boolean): Promise<void>;
    onRequest(fn: OnRequestHandler): Promise<() => Promise<void>>;
    onResponse(fn: OnResponseHandler): Promise<() => Page>;
    onClose(fn: (page: Page) => void): () => unknown;
}
export default PlaywrightDriver;
